#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>

int main(int argc, char *argv[]) {
  char *dev_in = "/dev/ipwm0";
  char *dev_out = "/dev/opwm0";
  int pause = 10000; /* 10 ms */

  int in = open(dev_in, O_RDONLY, 0);
  if ( in < 0 ) { perror(dev_in); exit(1); }
  int out = open(dev_out, O_WRONLY, 0);
  if ( out < 0 ) { perror(dev_out); exit(1); }

  while ( 1 ) {
    unsigned short chans[256];
    int nr = read(in, chans, sizeof(chans));
    if ( nr <= 0 ) {
      printf(".");
    } else {
      for ( int i=0; i<nr/2; ++i ) printf("%5d ", chans[i]);
      printf("\n");
      if ( write(out, chans, nr) != nr ) { perror("write"); exit(1); }
    }
    fflush(stdout);
    usleep(pause);
  }

  return 0;
}
